/* 
   Unix SMB/Netbios implementation.
   Version 1.0
   Discover the WINS server using DHCP.

   Copyright (C) Shirish Kalele 2001.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*/

#ident "@(#) $RCSfile$$Revision$$Date$"

#ifndef _DHCP_DISCOVER_WINS_H

#define _DHCP_DISCOVER_WINS_H

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 256
#endif

#define DHCP_CLIPORT 68
#define DHCP_SRVPORT 67

/* DHCP message types */
#define DHCPDISCOVER 1
#define DHCPOFFER    2
#define DHCPREQUEST  3
#define DHCPDECLINE  4 
#define DHCPACK      5
#define DHCPNAK      6
#define DHCPRELEASE  7
#define DHCPINFORM   8

/* DHCP option codes */
#define DHCPOP_PAD                          0x00
#define DHCPOP_NETBIOS_NAME_SERVERS         0x2C
#define DHCPOP_MSG_TYPE                     0x35
#define DHCPOP_SERVER_IDENTIFIER            0x36
#define DHCPOP_PARAM_LIST                   0x37
#define DHCPOP_END                          0xFF

#define DHCP_WAIT_TIME    5 /* seconds */

struct dhcp_pkt_t {
	unsigned char op;
	unsigned char htype;
	unsigned char hlen;
	unsigned char hops;

	unsigned int xid;

	unsigned short secs;
	unsigned short flags;

	unsigned int ciaddr;
	unsigned int yiaddr;
	unsigned int siaddr;
	unsigned int giaddr;
	unsigned char chaddr[16];
	unsigned char sname[64];
	unsigned char file[128];
	unsigned int magic_cookie;
	
	unsigned char option[1];
};

struct dhcp_option_t {
	unsigned char type;
	unsigned char len;
	unsigned char data[1];
};

#endif
